﻿using System;
using System.Web.UI.WebControls;
using System.Drawing;
using System.Drawing.Text;
using System.ComponentModel;

namespace GeradorDeCartoes
{
    public partial class Default : System.Web.UI.Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {
                if (!this.IsPostBack)
                {
                    // Pega a lista de cores
                    string[] colorArray = Enum.GetNames(typeof(KnownColor));
                    lstCorDeFundo.DataSource = colorArray;
                    lstCorDeFundo.DataBind();
                    //define a cor da fonte
                    lstCorDaFonte.DataSource = colorArray;
                    lstCorDaFonte.DataBind();
                    lstCorDaFonte.SelectedIndex = 34;
                    lstCorDaFonte.SelectedIndex = 163;
                    // define imagens
                    lstImagem.Items.Add("feliz");
                    lstImagem.Items.Add("aniversario1");
                    lstImagem.Items.Add("aniversario2");
                    lstImagem.Items.Add("anonovo1");
                    lstImagem.Items.Add("anonovo2");
                    lstImagem.Items.Add("maes1");
                    lstImagem.Items.Add("maes2");
                    lstImagem.Items.Add("namorados1");
                    lstImagem.Items.Add("namorados2");
                    lstImagem.Items.Add("pais1");
                    lstImagem.Items.Add("pais2");
                    lstImagem.Items.Add("amigos");
                    lstImagem.Items.Add("amizade");
                    lstImagem.SelectedIndex = -1;

                    // pega a lista de fontes disponíveis
                    InstalledFontCollection fonts = new InstalledFontCollection();
                    foreach (FontFamily family in fonts.Families)
                    {
                        lstNomeDaFonte.Items.Add(family.Name);
                    }

                    // Defina o estilo da borda
                    string[] borderStyleArray = Enum.GetNames(typeof(BorderStyle));
                    lstBorda.DataSource = borderStyleArray;
                    lstBorda.DataBind();

                    // Selecina a primeira opção
                    lstBorda.SelectedIndex = 0;
                }
       }

       protected void cmdAtualiza_Click(object sender, EventArgs e)
       {
           AtualizaCartao();
       }

       protected void AtualizaCartao()
       {
           // Atualiza a cor
           pnlCartao.BackColor = Color.FromName(lstCorDeFundo.SelectedItem.Text);
           lblTexto.ForeColor = Color.FromName(lstCorDaFonte.SelectedItem.Text);

           // Atualiza fonte
           lblTexto.Font.Name = lstNomeDaFonte.SelectedItem.Text;
           try
           {
               if (Int32.Parse(txtTamanhoDaFonte.Text) > 0)
               {
                   lblTexto.Font.Size = FontUnit.Point(Int32.Parse(txtTamanhoDaFonte.Text));
               }
           }
           catch
           {
               lblmsg.Text = "Tamanho da fonte inválido !";
           }

           try
           {
               if (Int32.Parse(txtTamanhoDaFonte.Text) > 0)
               {
                   lblTexto.Font.Size = FontUnit.Point(Int32.Parse(txtTamanhoDaFonte.Text));
               }
           }
           catch
           {
               lblmsg.Text = "Tamanho da fonte inválido !";
           }

           // localiza o TypeConverter adequado para a enumeração BorderStyle
           TypeConverter cnvrt = TypeDescriptor.GetConverter(typeof(BorderStyle));

           // Atualiza o estilo da borda usando o avlor do converter.
           pnlCartao.BorderStyle = (BorderStyle)cnvrt.ConvertFromString(lstBorda.SelectedItem.Text);

           atualizaImagem();

           // Define o texto
           lblTexto.Text = txtTexto.Text;
       }


       protected void lstImagem_SelectedIndexChanged(object sender, EventArgs e)
       {  
           //chama a rotina para atualizar a fonte
           atualizaImagem();
       }

       protected void atualizaImagem()
       {
           //verifica se é para exibir a imagem
           if (chkImagem.Checked)
           {
               //obtem a imagem selecionada e exibe
               if (lstImagem.SelectedIndex != -1)
               {
                   string nomeImagem = lstImagem.SelectedItem.Text + ".jpg";
                   imgDefault.ImageUrl = @"~/Imagens/" + nomeImagem;
                   imgDefault.Visible = true;
               }
           }
           else
           {
               //não exibe a imagem
               imgDefault.Visible = false;
           }
       }

       protected void ControlChanged(Object sender, EventArgs e)
       {
           // Atualiza o texto do cartão 
           AtualizaCartao();
       }
   }
}